/*****************************************************************************/
/* main.c : Module principal et ligne de commande
 * main.c : Main module and command line
 *
 *
 * TouxDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <locale.h>
#include <dlfcn.h>
#include <toutdoux.h>

#include "main.h"
#include "icons.h"
#include "configuration.h"


/*****************************************************************************/
/* Menu Principal */
/*****************************************************************************/
/* FIXME: mettre ne place une gnration totale et complte des menus par fichier XML : +tards */
static GnomeUIInfo menu_main_help_uiinfo[] =
{
  {GNOME_APP_UI_ITEM, N_("Customize"), NULL,
   customize_show, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_CUSTOM, 0, 0, NULL},
  {GNOME_APP_UI_ITEM, N_("Bookmarks"), NULL,
   bookmarks_show, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, menu_favorites_xpm, 'b', GDK_MOD1_MASK, NULL},
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_ITEM, N_("Presto"), NULL,
   presto_show, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, menu_presto_xpm, 0xFFBE, 0, NULL},
  {GNOME_APP_UI_ITEM, N_("User's manual"), NULL,
   td_app_menu_activate, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_BOOK_GREEN, 0, 0, NULL},
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_ITEM, N_("Plug-ins browser"), NULL,
   td_app_menu_activate, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_PLUGINS, 0, 0, NULL},
  {GNOME_APP_UI_ITEM, N_("About"), NULL,
   td_app_menu_activate, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT, 0, 0, NULL},
  GNOMEUIINFO_END
};

static GnomeUIInfo menu_main_import_export_uiinfo[] =
{
  GNOMEUIINFO_END
};            	

static GnomeUIInfo menu_main_template_uiinfo[] =
{
  {GNOME_APP_UI_ITEM, N_("Create template"), NULL,
   td_db_connect_close, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_BUILD, 'n', GDK_CONTROL_MASK, NULL},
  {GNOME_APP_UI_ITEM, N_("Open template..."), NULL,
   td_db_connect_load, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN, 0, 0, NULL},
  GNOMEUIINFO_END
};            	

static GnomeUIInfo menu_main_file_uiinfo[] =
{
  {GNOME_APP_UI_ITEM, N_("Save"), NULL,
   td_db_connect_save, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE, 's', GDK_CONTROL_MASK, NULL},
  {GNOME_APP_UI_ITEM, N_("Save as..."), NULL,
   td_db_connect_save, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE_AS, 0, 0, NULL},
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_ITEM, N_("Quit"), NULL,
   quit_toutdoux, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXIT, 'q', GDK_CONTROL_MASK, NULL},
  GNOMEUIINFO_END
};            	

static GnomeUIInfo menu_main_dialog_uiinfo[] =
{
  {GNOME_APP_UI_ITEM, N_("Bench"), NULL,
   editprop_show, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_BENCH, 'w', GDK_MOD1_MASK, NULL},
/*    {GNOME_APP_UI_ITEM, N_("Editor"), NULL, */
/*     td_app_menu_activate, NULL, NULL, */
/*     GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_EDITOR, 'e', GDK_MOD1_MASK, NULL}, */
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_ITEM, N_("Messages"), NULL,
   td_app_menu_activate, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, menu_console_xpm, 'x', GDK_MOD1_MASK, NULL},
  GNOMEUIINFO_END
};            	

static GnomeUIInfo menu_main_tools_uiinfo[] =
{
  {GNOME_APP_UI_ITEM, N_("Edit template"), NULL,
   cogitation_show, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_BUILD, 't', GDK_MOD1_MASK, NULL},
  {GNOME_APP_UI_ITEM, N_("SQL console"), NULL,
   td_app_menu_activate, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_COMMAND, 'q', GDK_MOD1_MASK, NULL},
/*    {GNOME_APP_UI_ITEM, N_("Manage database"), NULL, */
/*     td_app_menu_activate, NULL, NULL, */
/*     GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_DATABASE, 0, 0, NULL}, */
  GNOMEUIINFO_END
};

static GnomeUIInfo menu_main_debug_uiinfo[] =
{
  GNOMEUIINFO_END
};

static GnomeUIInfo menu_main_uiinfo[] =
{
  {GNOME_APP_UI_SUBTREE, N_("File"), NULL,
   menu_main_file_uiinfo, NULL, NULL,
   GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN, 0, 0, NULL},
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_SUBTREE, N_("Tools"), NULL,
   menu_main_tools_uiinfo, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_TOOLS, 0, 0, NULL},
  {GNOME_APP_UI_SUBTREE, N_("Dialogs"), NULL,
   menu_main_dialog_uiinfo, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_LIST_DIALOG, 0, 0, NULL},
  GNOMEUIINFO_SEPARATOR,
  {GNOME_APP_UI_SUBTREE, N_("Debug"), NULL,
   menu_main_debug_uiinfo, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_MENU_DEBUG, 0, 0, NULL},
  {GNOME_APP_UI_SUBTREE, N_("Help"), NULL,
   menu_main_help_uiinfo, NULL, NULL,
   GNOME_APP_PIXMAP_DATA, TD_STOCK_MENU_HELP, 0, 0, NULL},
  GNOMEUIINFO_END
};


/*****************************************************************************/
/* Definition */
/*****************************************************************************/
GtkObject *app_def (void)
{
  GtkObject *ret;
  GtkObject *about;
  GtkObject *admin_field[2];
  GtkObject *palette;
  GtkObject *editprop;
  GtkObject *relation;
  GtkObject *message;
  GtkObject *message_mod;
  GtkObject *message_mod_tree;
  GtkObject *field[2];
  GtkObject *menu[11];
  GtkObject *icon[10];
  GtkObject *icon_equal[10];
  void (*symbol)();

  GtkAccelGroup *accel_group;
  GtkWidget *menu1;
  GtkWidget *menu1_item[7];
  GtkWidget *menu2;
  GtkWidget *menu2_item[8];
  GtkWidget *menu3;
  GtkWidget *menu3_item[9];
  GtkWidget *menu4_item;

  /* Application */
  ret = td_app_new ();
  gtk_object_set (GTK_OBJECT (ret),
		  "mode_build", mode_build_popt,
		  "mode_debug", mode_debug_popt,
		  "mode_nocolor", mode_nocolor_popt, NULL);

  /* About */
  about = td_about_new ();
  gtk_object_set (GTK_OBJECT (about), 
		  "name", TD_PACKAGE,
		  "version", g_strdup_printf("%s (%s)", TD_VERSION, TD_DATEVERSION),
		  "copyright", "Copyright (c) 2000-2001 Philippe Roy",
		  "license", _("ToutDoux is a free software, covered by the GNU General Public License."),
		  "logo", g_strdup_printf("%s/share/pixmaps/%s/logo.png", TD_PACKAGE_DATA_DIR, TD_PACKAGE_DIR),
		  "web", "http://www.toutdoux.org", NULL);
  td_app_set_about (TD_APP (ret), about);

  /* Champs d'administration */
  admin_field[0] = td_field_new ();
  gtk_object_set (GTK_OBJECT (admin_field[0]),
		  "name", "td_id",
		  "name_intl", "td_id",
		  "type", "int4", NULL);
  td_app_add_admin_field (TD_APP (ret), admin_field[0]);

  admin_field[1] = td_field_new ();
  gtk_object_set (GTK_OBJECT (admin_field[1]),
		  "name", "td_obso",
		  "name_intl", "td_obso",
		  "type", "bool", NULL);
  td_app_add_admin_field (TD_APP (ret), admin_field[1]);

  /* Menu gnral */
  accel_group = gtk_accel_group_new();
  td_app_set_accel_group (TD_APP (ret), accel_group);
  td_app_set_menu_main (TD_APP (ret), menu_main_uiinfo);

  /* Modules chargeables sur menu */
  menu[1] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[1]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Help"), _("About")),
		  "file", "libhelp_about.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[1]);

  menu[2] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[2]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Help"), _("Plug-ins details")),
		  "file", "libhelp_xts.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[2]);

  menu[3] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[3]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Tools"), _("Manage database")),
		  "file", "libcommunication_db.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[3]);

  menu[4] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[4]),
		  "type", "manual",
		  "path", g_strdup_printf ("%s/%s", _("Help"), _("User's manual")),
		  "file", g_strdup_printf ("index.html"), NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[4]);

  menu[5] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[5]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Tools"), _("Messages")),
		  "file", "libdialog_messages.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[5]);
  menu[6] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[6]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Dialogs"), _("Messages")),
		  "file", "libdialog_messages.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[6]);

  menu[7] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[7]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Tools"), _("Editor")),
		  "file", "libdialog_editor.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[7]);
  menu[8] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[8]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Dialogs"), _("Editor")),
		  "file", "libdialog_editor.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[8]);

  menu[9] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[9]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Tools"), _("SQL console")),
		  "file", "libtools_query.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[9]);
  menu[10] = td_app_menu_new ();
  gtk_object_set (GTK_OBJECT (menu[10]),
		  "type", "module",
		  "path", g_strdup_printf ("%s/%s", _("Tools"), _("SQL console")),
		  "file", "libtools_query.so",
		  "symbol", "plugins_init", NULL);
  td_app_add_menu_mod (TD_APP (ret), menu[10]);

  /* Palette */
  /* FIXME: mettre ne place une gnration totale et complte des menus par fichier XML : +tards */
  palette = td_app_palette_new ();
  td_app_set_palette (TD_APP (ret), palette);
  td_app_set_menu_palette (TD_APP (ret), gtk_menu_bar_new ());
  (gpointer*) symbol = td_dlsym (PLUGINS_CORE_BOOKMARKS, NULL, "libhelp_bookmarks.so", "plugins_start");
  symbol (TD_APP (ret));

  /* Menu fichier */
  menu1_item[0] = gtk_menu_item_new_with_label (_("File"));
  gtk_widget_show (menu1_item[0]);
  gtk_menu_bar_append (GTK_MENU_BAR (TD_APP (ret)->menu_palette), menu1_item[0]);
  menu1 = gtk_menu_new ();
  gtdk_menu_item_set_submenu (GTK_MENU_ITEM (menu1_item[0]), menu1);

  /* Sous-menu nouveau */
  menu1_item[1] = gtdk_menu_item_new (_("New"), NULL, "list_new.xpm");
  gtk_menu_append (GTK_MENU (menu1), menu1_item[1]);
  td_app_set_menu_templates (TD_APP (ret), menu1_item[1]);
  (gpointer*) symbol = td_dlsym (PLUGINS_CORE_BOOKMARKS, NULL, "libhelp_bookmarks.so", "plugins_menu_def_templates");
  symbol (menu1_item[1], accel_group);
  menu1_item[6] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu1), menu1_item[6]);

  /* Sous-menu ouvrir */
  menu1_item[2] = gtdk_menu_item_new (_("Open"), NULL, "list_open.xpm");
  gtk_menu_append (GTK_MENU (menu1), menu1_item[2]);
  td_app_set_menu_history (TD_APP (ret), menu1_item[2]);
  (gpointer*) symbol = td_dlsym (PLUGINS_CORE_BOOKMARKS, NULL, "libhelp_bookmarks.so", "plugins_menu_def_history");
  symbol (menu1_item[2], accel_group);

  /* Sous-menu favoris */
  menu1_item[3] = gtdk_menu_item_new (_("Favorites"), NULL, "list_bookmarks.xpm");
  gtk_menu_append (GTK_MENU (menu1), menu1_item[3]);
  td_app_set_menu_favorites (TD_APP (ret), menu1_item[3]);
  (gpointer*) symbol = td_dlsym (PLUGINS_CORE_BOOKMARKS, NULL, "libhelp_bookmarks.so", "plugins_menu_def_favorites");
  symbol (menu1_item[3], accel_group);

  /* Quitter */
  menu1_item[4] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu1), menu1_item[4]);
  menu1_item[5] = gtdk_menu_item_accel_new (_("Quit"), NULL, "list_quit.xpm", accel_group, GDK_Q, GDK_CONTROL_MASK);
  gtk_menu_append (GTK_MENU (menu1), menu1_item[5]);
  gtk_signal_connect (GTK_OBJECT (menu1_item[5]), "activate", GTK_SIGNAL_FUNC (quit_toutdoux), NULL);

  /* Menu outils */
  menu2_item[0] = gtk_menu_item_new_with_label (_("Tools"));
  gtk_widget_show (menu2_item[0]);
  gtk_menu_bar_append (GTK_MENU_BAR (TD_APP (ret)->menu_palette), menu2_item[0]);
  menu2 = gtk_menu_new ();
  gtdk_menu_item_set_submenu (GTK_MENU_ITEM (menu2_item[0]), menu2);

  menu2_item[1] = gtdk_menu_item_accel_new (_("Edit template"), NULL, "list_build.xpm", accel_group, GDK_T, GDK_MOD1_MASK);
  gtk_signal_connect (GTK_OBJECT (menu2_item[1]), "activate", GTK_SIGNAL_FUNC (cogitation_show), NULL);
  gtk_menu_append (GTK_MENU (menu2), menu2_item[1]);
  menu2_item[2] = gtdk_menu_item_accel_new (_("SQL console"), NULL, "list_command.xpm", accel_group, GDK_Q, GDK_MOD1_MASK);
  gtk_signal_connect (GTK_OBJECT (menu2_item[2]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Tools"), _("SQL console")));
  gtk_menu_append (GTK_MENU (menu2), menu2_item[2]);
  /*  menu2_item[2] = gtdk_menu_item_new (_("Manage database"), NULL, "list_database.xpm"); */
/*    gtk_signal_connect (GTK_OBJECT (menu2_item[2]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Tools"), _("Manage database"))); */
/*    gtk_menu_append (GTK_MENU (menu2), menu2_item[2]); */
  menu2_item[3] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu2), menu2_item[3]);

  menu2_item[4] = gtdk_menu_item_accel_new (_("Bench"), NULL, "list_bench.xpm", accel_group, GDK_W, GDK_MOD1_MASK);
  gtk_signal_connect (GTK_OBJECT (menu2_item[4]), "activate", GTK_SIGNAL_FUNC (editprop_show), NULL);
  gtk_menu_append (GTK_MENU (menu2), menu2_item[4]);
/*    menu2_item[6] = gtdk_menu_item_accel_new (_("Editor"), NULL, "list_editor.xpm", accel_group, GDK_E, GDK_MOD1_MASK); */
/*    gtk_signal_connect (GTK_OBJECT (menu2_item[6]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Tools"), _("Editor"))); */
/*    gtk_menu_append (GTK_MENU (menu2), menu2_item[6]); */
  menu2_item[7] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu2), menu2_item[7]);

  menu2_item[5] = gtdk_menu_item_accel_new (_("Messages"), NULL, "list_console.xpm", accel_group, GDK_X, GDK_MOD1_MASK);
  gtk_signal_connect (GTK_OBJECT (menu2_item[5]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Tools"), _("Messages")));
  gtk_menu_append (GTK_MENU (menu2), menu2_item[5]);

  /* Menu aide */
  menu3_item[0] = gtk_menu_item_new_with_label (_("Help"));
  gtk_widget_show (menu3_item[0]);
  gtk_menu_bar_append (GTK_MENU_BAR (TD_APP (ret)->menu_palette), menu3_item[0]);
  menu3 = gtk_menu_new ();
  gtdk_menu_item_set_submenu (GTK_MENU_ITEM (menu3_item[0]), menu3);

  menu3_item[1] = gtdk_menu_item_new (_("Customize"), NULL, "list_preferences.xpm");
  gtk_signal_connect (GTK_OBJECT (menu3_item[1]), "activate", GTK_SIGNAL_FUNC (customize_show), NULL);
  gtk_menu_append (GTK_MENU (menu3), menu3_item[1]);
  menu3_item[2] = gtdk_menu_item_accel_new (_("Bookmarks"), NULL, "list_bookmarks.xpm", accel_group, GDK_B, GDK_MOD1_MASK);
  gtk_signal_connect (GTK_OBJECT (menu3_item[2]), "activate", GTK_SIGNAL_FUNC (bookmarks_show), NULL);
  gtk_menu_append (GTK_MENU (menu3), menu3_item[2]);
  menu3_item[3] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu3), menu3_item[3]);

  menu3_item[4] = gtdk_menu_item_new (_("User's manual"), NULL, "list_manual.xpm");
  gtk_signal_connect (GTK_OBJECT (menu3_item[4]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Help"), _("User's manual")));
  gtk_menu_append (GTK_MENU (menu3), menu3_item[4]);
  menu3_item[5] = gtdk_menu_item_new (NULL, NULL, NULL);
  gtk_menu_append (GTK_MENU (menu3), menu3_item[5]);

  menu3_item[6] = gtdk_menu_item_accel_new (_("Presto"), NULL, "list_presto.xpm", accel_group, 0xFFBE, 0);
  gtk_signal_connect (GTK_OBJECT (menu3_item[6]), "activate", GTK_SIGNAL_FUNC (presto_show), NULL);
  gtk_menu_append (GTK_MENU (menu3), menu3_item[6]);
  menu3_item[7] = gtdk_menu_item_new (_("Plug-ins details"), NULL, "list_plugins.xpm");
  gtk_signal_connect (GTK_OBJECT (menu3_item[7]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Help"), _("Plug-ins details")));
  gtk_menu_append (GTK_MENU (menu3), menu3_item[7]);
  menu3_item[8] = gtdk_menu_item_new (_("About"), NULL, "list_about.xpm");
  gtk_signal_connect (GTK_OBJECT (menu3_item[8]), "activate", GTK_SIGNAL_FUNC (td_app_menu_gtk_activate), g_strdup_printf ("%s/%s", _("Help"), _("About")));
  gtk_menu_append (GTK_MENU (menu3), menu3_item[8]);

  /* Editeur des proprits */
  editprop = td_app_editprop_new ();
  td_app_set_editprop (TD_APP (ret), editprop);
  return ret;
}


/*****************************************************************************/
/* Popt */
/*****************************************************************************/
gchar *file_popt;
gboolean mode_debug_popt;
gboolean mode_build_popt;
gboolean mode_nocolor_popt;
const char **arguments = NULL;
poptContext pctx;
const struct poptOption parametres[] ={
  {
    "file", 'f', POPT_ARG_STRING, &file_popt, 0, N_("Specify the file (optional)"), N_("FILE"),
  },
  {
    "build", 'b', POPT_ARG_NONE, &mode_build_popt, 0, N_("build mode"), NULL
  },
  {
    "debug", 'd', POPT_ARG_NONE, &mode_debug_popt, 0, N_("debug mode"), NULL
  },
  {
    "nocolor", 0, POPT_ARG_NONE, &mode_nocolor_popt, 0, N_("no colors mode"), NULL
  },
  {
    NULL, '\0', 0, NULL, 0, NULL, NULL
  }
};


/*****************************************************************************/
/* Main */
/*****************************************************************************/
int main (int argc, char *argv[])
{
  GtkObject *connect;

  /* Internationalisation */
  setlocale (LC_ALL, "");
  bindtextdomain (TD_PACKAGE, TD_PACKAGE_LOCALE_DIR);
  textdomain (TD_PACKAGE);

  /* Initialisation */
  gnome_init_with_popt_table (TD_PACKAGE, TD_VERSION, argc, argv, parametres, 0, &pctx);
  arguments = poptGetArgs (pctx);
  gnome_config_push_prefix ("ToutDoux/");
  td_init ();
  correction ();
  td_palette_message (NULL, _("Starting"), "begin");
  APP = app_def ();
  td_app_create (TD_APP (APP));

  /* Go ! */
  td_palette_message (g_strdup_printf ("%s...", _("Starting")), NULL, "message");
  FLAG_NO_REFRESH_PALLETTE_MESSAGE = TRUE;
  configuration_file ();
  configuration_gui ();
  app_mod_core_def ();
  FLAG_NO_REFRESH_PALLETTE_MESSAGE = FALSE;
  td_palette_message (NULL, _("Starting"), "done");
  td_palette_message (NULL, _("Starting"), "end");

  /* Fichier en ligne de commande *//* FIXME: ajouter URL et base de donnes : +tards */
  if ((!file_popt) && (argc>1) && (argv[1][0] != '-'))
    file_popt = g_strdup_printf ("%s", argv[1]);
  if (file_popt)
    {
      connect = td_db_connect_new ();
      gtk_object_set (GTK_OBJECT (connect), "name", file_popt, "file", file_popt, "type", "file", NULL);
      td_db_connect_load (NULL, connect);
    }
  gtk_main ();
  return 0;
}

/*****************************************************************************/
/* Menu *//* FIXME: Virer les menus GNOME par ceux de GTK+ : +tards */
/*****************************************************************************/
void editprop_show (void)
{
  td_app_editprop_show (TD_APP_EDITPROP (TD_APP (APP)->editprop));
}

void quit_toutdoux (void)
{
  td_app_quit (TD_APP (APP));
}

void cogitation_show (void)
{
  int i;
  gboolean bool_tmp;

  /* Recherche du module */
  bool_tmp = FALSE;
  for (i=0; i<g_list_length (TD_APP (APP)->mod_data); i++)
    if (!strcmp (TD_MOD (g_list_nth_data (TD_APP (APP)->mod_data, i))->name, "cogitation"))
      {
	bool_tmp = TRUE;
	break;
      }
  if (!bool_tmp)
    {
      td_palette_message (NULL, _("Starting cogitation"), "begin");
      td_palette_message (g_strdup_printf ("%s...", _("Starting cogitation")), NULL, "message");
      FLAG_NO_REFRESH_PALLETTE_MESSAGE = TRUE;
      if (!td_app_add_mod_data (TD_APP (APP), NULL, "libcogitation.so"))
	td_palette_message (_("Starting cogitation"), _("Starting cogitation : Module not complete"), "stop");
      td_app_editprop_add_mod (TD_APP_EDITPROP (TD_APP (APP)->editprop), g_list_nth_data (TD_APP (APP)->mod_data, i));
      FLAG_NO_REFRESH_PALLETTE_MESSAGE = FALSE;
      td_palette_message (NULL, _("Starting cogitation"), "end");
    }

  /* Go ! */
  td_mod_show (g_list_nth_data (TD_APP(APP)->mod_data, i));
}

void bookmarks_show (void)
{
  int i;
  gboolean bool_tmp;

  /* Recherche du module */
  bool_tmp = FALSE;
  for (i=0; i<g_list_length (TD_APP (APP)->mod_data); i++)
    if (!strcmp (TD_MOD (g_list_nth_data (TD_APP (APP)->mod_data, i))->name, "help_bookmarks"))
      {
	bool_tmp = TRUE;
	break;
      }
  if (!bool_tmp)
    {
      td_palette_message (NULL, _("Starting bookmarks"), "begin");
      td_palette_message (g_strdup_printf ("%s...", _("Starting bookmarks")), NULL, "message");
      FLAG_NO_REFRESH_PALLETTE_MESSAGE = TRUE;
      if (!td_app_add_mod_data (TD_APP (APP), NULL, "libhelp_bookmarks.so"))
	td_palette_message (_("Starting cogitation"), _("Starting bookmarks : Module not complete"), "stop");
      td_app_editprop_add_mod (TD_APP_EDITPROP (TD_APP (APP)->editprop), g_list_nth_data (TD_APP (APP)->mod_data, i));
      FLAG_NO_REFRESH_PALLETTE_MESSAGE = FALSE;
      td_palette_message (NULL, _("Starting bookmarks"), "end");
    }

  /* Go ! */
  td_mod_show (g_list_nth_data (TD_APP (APP)->mod_data, i));
}

void communication_db_show (void)
{
  td_app_mod_core_activate (TD_APP (APP), NULL, "libcommunication_db.so", "plugins_show");
}

void customize_show (void)
{
  td_app_custom_show (TD_APP (APP));
}

void presto_show (void)
{
  td_app_presto_show (TD_APP (APP));
}

/*****************************************************************************/
/* Module noyaux */
/*****************************************************************************/
void app_mod_core_def (void)
{
  void (*symbol)();

  /* Interface de base de donnes locale : PLUGINS_CORE[0] */
  if (!strcmp (td_mod_custom_value ("app", "database", "backend", "database management system"), "MySQL"))
    PLUGINS_CORE_DATABASE = dlopen (g_strdup_printf ("%s%s", TD_PACKAGE_PLUGINS_DIR, "libdatabase_mysql.so"), RTLD_LAZY);
  else
    PLUGINS_CORE_DATABASE = dlopen (g_strdup_printf ("%s%s", TD_PACKAGE_PLUGINS_DIR, "libdatabase_postgresql.so"), RTLD_LAZY);
  (gpointer*) symbol = dlsym (PLUGINS_CORE_DATABASE, "plugins_init");
  symbol ();

  td_app_add_mod_core (NULL, NULL, "libdialog_messages.so"); /* Commnunication : URL : PLUGINS_CORE[1] */
  td_app_add_mod_core (NULL, NULL, "libcommunication_url.so"); /* Commnunication : Base de donnes : PLUGINS_CORE[2] */
/*    td_app_add_mod_core (NULL, NULL, "libcommunication_db.so");  */
  /* Personnalisation : PLUGINS_CORE[3] */
  td_app_add_mod_core (NULL, NULL, "libhelp_customize.so"); /* Customize : PLUGINS_CORE[4] */
  td_app_add_mod_core (NULL, NULL, "libhelp_doc.so"); /* Presto : PLUGINS_CORE[5] */
  td_app_add_mod_core (NULL, NULL, "libtools_import_export.so"); /* Import-export : PLUGINS_CORE[6] */
}

