/*****************************************************************************/
/* td_db_mod_editprop.c : Objet Gtk+
 * td_db_mod_editprop.c : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "commons.h"
#include "database.h"

#include "td_db_mod_editprop.h"

/*****************************************************************************/
/*** Arguments */
/*****************************************************************************/
static GtkObjectClass *parent_class = NULL;

enum {
  ARG_0,
  ARG_NAME,
};

static void td_db_mod_editprop_set_name (TdDbModEditprop *db_mod_editprop, gchar *name)
{
  g_return_if_fail (db_mod_editprop != NULL);
  g_return_if_fail (TD_IS_DB_MOD_EDITPROP (db_mod_editprop));
  if (db_mod_editprop->name != name)
    db_mod_editprop->name = name;
}

static void td_db_mod_editprop_set_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdDbModEditprop *db_mod_editprop;
  db_mod_editprop = TD_DB_MOD_EDITPROP (object);
  switch (arg_id)
    {
    case ARG_NAME:
      td_db_mod_editprop_set_name (db_mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    default:
      break;
    }
}

static void td_db_mod_editprop_get_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdDbModEditprop *db_mod_editprop;
  db_mod_editprop = TD_DB_MOD_EDITPROP (object);
   switch (arg_id)
    {
    case ARG_NAME:
      GTK_VALUE_STRING (*arg) = db_mod_editprop->name;
      break;
    default:
      arg->type = GTK_TYPE_INVALID;
      break;
    }
}

/*****************************************************************************/
/*** Initialisation */
/*****************************************************************************/
static void td_db_mod_editprop_init (TdDbModEditprop *db_mod_editprop)
{
  db_mod_editprop->name = NULL;
  db_mod_editprop->property_name = NULL;
  db_mod_editprop->property_value = NULL;
}

static void td_db_mod_editprop_class_init (TdDbModEditpropClass *klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*) klass;
  parent_class = gtk_type_class (gtk_object_get_type());
  gtk_object_add_arg_type ("TdDbModEditprop::name", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_NAME);
  object_class->set_arg = td_db_mod_editprop_set_arg;
  object_class->get_arg = td_db_mod_editprop_get_arg;
  klass->add_property = td_db_mod_editprop_add_property;
}

GtkType td_db_mod_editprop_get_type (void)
{
  static GtkType db_mod_editprop_type = 0;
  if (!db_mod_editprop_type)
    {
      static const GtkTypeInfo db_mod_editprop_info =
      {
  	"TdDbModEditprop", sizeof (TdDbModEditprop), sizeof (TdDbModEditpropClass),
  	(GtkClassInitFunc) td_db_mod_editprop_class_init,
	(GtkObjectInitFunc) td_db_mod_editprop_init,
	NULL, NULL, (GtkClassInitFunc) NULL,
      };
      db_mod_editprop_type = gtk_type_unique (GTK_TYPE_OBJECT, &db_mod_editprop_info);
    }
  return db_mod_editprop_type;
}

/**
 * td_db_mod_editprop_new:
 * 
 * fr: Cr un nouveau paramtrage d'tabli
 *
 * en: Creates new bench parameters
 * 
 * Return value: bench parameters
 **/

GtkObject *td_db_mod_editprop_new (void)
{
  return GTK_OBJECT (gtk_type_new (td_db_mod_editprop_get_type ()));
}

/*****************************************************************************/
/*** Affectations - Allocations */
/*****************************************************************************/

/**
 * td_db_mod_editprop_add_property:
 * @db_mod_editprop: bench parameters
 * @property_name: property's name
 * @property_value: property's value
 * 
 * fr: Ajoute la proprit au paramtrage de l'tabli
 *
 * en: Add the property to bench parameters
 **/

void td_db_mod_editprop_add_property (TdDbModEditprop *db_mod_editprop, gchar *property_name, gchar *property_value)
{
  g_return_if_fail (db_mod_editprop != NULL);
  g_return_if_fail (TD_IS_DB_MOD_EDITPROP (db_mod_editprop));
  db_mod_editprop->property_name = g_list_append (db_mod_editprop->property_name, property_name);
  db_mod_editprop->property_value = g_list_append (db_mod_editprop->property_value, property_value);
}

/*****************************************************************************/
/*** Fichier - File */
/*****************************************************************************/

/**
 * td_db_mod_editprop_load:
 * @doc: XML document
 * @ns: XML namespace
 * @cur: XML node
 * 
 * fr: Retourne le paramtrage de l'tabli du module correspondant  la localisation XML
 *
 * en: Return the bench parameters of module corresponding the XML location
 * 
 * Return value: bench parameters
 **/

GtkObject *td_db_mod_editprop_load (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur)
{
  GtkObject *ret;

  /*** Nom - Name */
  ret = td_db_mod_editprop_new ();
  gtk_object_set (GTK_OBJECT (ret), "name", xmlGetProp (cur, "name"), NULL);

  /*** Proprits - Properties */
  cur = cur->xmlChildrenNode->xmlChildrenNode;
  while (cur)
    {
      if (!strcmp (cur->name, "property"))
	td_db_mod_editprop_add_property (TD_DB_MOD_EDITPROP (ret), xmlGetProp (cur, "name"), xmlGetProp (cur, "value"));
      cur = cur->next;
    }
  return (ret);
}


