/*****************************************************************************/
/* td_db_mod_table_field.h : Objet Gtk+
 * td_db_mod_table_field.h : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "commons.h"
#include "td_db_mod_table_field.h"

/*****************************************************************************/
/*** Arguments */
/*****************************************************************************/
static GtkObjectClass *parent_class = NULL;

enum {
  ARG_0,
  ARG_NAME,
  ARG_TABLE_FIELD,
};

static void td_db_mod_table_field_set_name (TdDbModTableField *db_mod_table_field, gchar *name)
{
  g_return_if_fail (db_mod_table_field != NULL);
  g_return_if_fail (TD_IS_DB_MOD_TABLE_FIELD (db_mod_table_field));
  if (db_mod_table_field->name != name)
    db_mod_table_field->name = name;
}

static void td_db_mod_table_field_set_table_field (TdDbModTableField *db_mod_table_field, gchar *table_field)
{
  g_return_if_fail (db_mod_table_field != NULL);
  g_return_if_fail (TD_IS_DB_MOD_TABLE_FIELD (db_mod_table_field));
  if (db_mod_table_field->table_field != table_field)
    db_mod_table_field->table_field = table_field;
}

static void td_db_mod_table_field_set_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdDbModTableField *db_mod_table_field;
  db_mod_table_field = TD_DB_MOD_TABLE_FIELD (object);
  switch (arg_id)
    {
    case ARG_NAME:
      td_db_mod_table_field_set_name (db_mod_table_field, GTK_VALUE_STRING (*arg));
      break;
    case ARG_TABLE_FIELD:
      td_db_mod_table_field_set_table_field (db_mod_table_field, GTK_VALUE_STRING (*arg));
      break;
    default:
      break;
    }
}

static void td_db_mod_table_field_get_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdDbModTableField *db_mod_table_field;
  db_mod_table_field = TD_DB_MOD_TABLE_FIELD (object);
   switch (arg_id)
    {
    case ARG_NAME:
      GTK_VALUE_STRING (*arg) = db_mod_table_field->name;
      break;
    case ARG_TABLE_FIELD:
      GTK_VALUE_STRING (*arg) = db_mod_table_field->table_field;
      break;
    }
}

/*****************************************************************************/
/*** Initialisation */
/*****************************************************************************/
static void td_db_mod_table_field_init (TdDbModTableField *db_mod_table_field)
{
  db_mod_table_field->name = NULL;
  db_mod_table_field->table_field = NULL;
  db_mod_table_field->property_name = NULL;
  db_mod_table_field->property_value = NULL;
}

static void td_db_mod_table_field_class_init (TdDbModTableFieldClass *klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*) klass;
  parent_class = gtk_type_class (gtk_object_get_type());
  gtk_object_add_arg_type ("TdDbModTableField::name", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_NAME);
  gtk_object_add_arg_type ("TdDbModTableField::table_field", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_TABLE_FIELD);
  object_class->set_arg = td_db_mod_table_field_set_arg;
  object_class->get_arg = td_db_mod_table_field_get_arg;
  klass->add_property = td_db_mod_table_field_add_property;
}

GtkType td_db_mod_table_field_get_type (void)
{
  static GtkType db_mod_table_field_type = 0;
  if (!db_mod_table_field_type)
    {
      static const GtkTypeInfo db_mod_table_field_info =
      {
  	"TdDbModTableField", sizeof (TdDbModTableField), sizeof (TdDbModTableFieldClass),
  	(GtkClassInitFunc) td_db_mod_table_field_class_init,
	(GtkObjectInitFunc) td_db_mod_table_field_init,
	NULL, NULL, (GtkClassInitFunc) NULL,
      };
      db_mod_table_field_type = gtk_type_unique (GTK_TYPE_OBJECT, &db_mod_table_field_info);
    }
  return db_mod_table_field_type;
}

/**
 * td_db_mod_table_field_new:
 * 
 * fr: Cr un nouveau paramtrage de champs
 *
 * en: Creates new field parameters
 * 
 * Return value: field parameters
 **/

GtkObject *td_db_mod_table_field_new (void)
{
  return GTK_OBJECT (gtk_type_new (td_db_mod_table_field_get_type ()));
}

/*****************************************************************************/
/*** Affectations - Allocations */
/*****************************************************************************/

/**
 * td_db_mod_table_field_add_property:
 * @db_mod_table_field: field parameters
 * @property_name: property's name
 * @property_value: property's value
 * 
 * fr: Ajoute la proprit au paramtrage du champs
 *
 * en: Add the property to field parameters
 **/

void td_db_mod_table_field_add_property (TdDbModTableField *db_mod_table_field, gchar *property_name, gchar *property_value)
{
  g_return_if_fail (db_mod_table_field != NULL);
  g_return_if_fail (TD_IS_DB_MOD_TABLE_FIELD (db_mod_table_field));
  db_mod_table_field->property_name = g_list_append (db_mod_table_field->property_name, property_name);
  db_mod_table_field->property_value = g_list_append (db_mod_table_field->property_value, property_value);
}

/*****************************************************************************/
/*** Commandes - Commands */
/*****************************************************************************/

/**
 * td_db_mod_table_field_property_value:
 * @db_mod_table_field: field parameters
 * @property_name: property name
 * 
 * fr: Retourne la valeur de la proprit du champs
 *
 * en: Return the value of field property
 * 
 * Return value: string
 **/

gchar *td_db_mod_table_field_property_value (TdDbModTableField *db_mod_table_field, gchar *property_name)
{
  int i;
  for (i=0; i<g_list_length (db_mod_table_field->property_name); i++)
    if (!strcmp ((gchar*) (g_list_nth_data (db_mod_table_field->property_name, i)), property_name))
      return (g_list_nth_data (db_mod_table_field->property_value, i));
  return NULL;
}

/*****************************************************************************/
/*** Fichier - File */
/*****************************************************************************/

/**
 * td_db_mod_table_field_load:
 * @doc: XML document
 * @ns: XML namespace
 * @cur: XML node
 * 
 * fr: Retourne le paramtrage du champs de module correspondant  la localisation XML
 *
 * en: Return the field parameters of module corresponding the XML location
 * 
 * Return value: field parameters
 **/

GtkObject *td_db_mod_table_field_load (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur)
{
  GtkObject *ret;

  /*** Champs - Field */
  ret = td_db_mod_table_field_new ();
  gtk_object_set (GTK_OBJECT (ret), 
		  "name", xmlGetProp (cur, "name"), 
		  "table_field", xmlGetProp (cur, "table_field"), NULL);

  /*** Proprits - Properties */
  cur = cur->xmlChildrenNode->xmlChildrenNode;
  while (cur)
    {
      if (!strcmp (cur->name, "property"))
	td_db_mod_table_field_add_property (TD_DB_MOD_TABLE_FIELD (ret), xmlGetProp (cur, "name"), xmlGetProp (cur, "value"));
      cur = cur->next;
    }
  return (ret);
}





