/*****************************************************************************/
/* td_mod_editprop.c : Objet Gtk+
 * td_mod_editprop.c : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000-2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "commons.h"
#include "database.h"

#include "td_mod.h"
#include "td_mod_editprop.h"

/*****************************************************************************/
/*** Arguments */
/*****************************************************************************/
static GtkObjectClass *parent_class = NULL;

enum {
  ARG_0,
  ARG_NAME,
  ARG_NAME_INTL,
  ARG_WIDGET_DATA1,
  ARG_WIDGET_DATA2,
  ARG_TYPE,
  ARG_QUERY_REFRESH,
  ARG_QUERY_VISIBLE,
  ARG_QUERY_UNSENSITIVE,
  ARG_QUERY_LIST,
};

void td_mod_editprop_set_name (TdModEditprop *mod_editprop, gchar *name)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->name != name)
    mod_editprop->name = name;
}

void td_mod_editprop_set_name_intl (TdModEditprop *mod_editprop, gchar *name_intl)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->name_intl != name_intl)
    mod_editprop->name_intl = name_intl;
}

void td_mod_editprop_set_widget_data1 (TdModEditprop *mod_editprop, gchar *widget_data1)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->widget_data1 != widget_data1)
    mod_editprop->widget_data1 = widget_data1;
}

void td_mod_editprop_set_widget_data2 (TdModEditprop *mod_editprop, gchar *widget_data2)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->widget_data2 != widget_data2)
    mod_editprop->widget_data2 = widget_data2;
}

void td_mod_editprop_set_type (TdModEditprop *mod_editprop, gchar *type)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->type != type)
    mod_editprop->type = type;
}

void td_mod_editprop_set_query_refresh (TdModEditprop *mod_editprop, gchar *query_refresh)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->query_refresh != query_refresh)
    mod_editprop->query_refresh = query_refresh;
}

void td_mod_editprop_set_query_visible (TdModEditprop *mod_editprop, gchar *query_visible)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->query_visible != query_visible)
    mod_editprop->query_visible = query_visible;
}

void td_mod_editprop_set_query_unsensitive (TdModEditprop *mod_editprop, gchar *query_unsensitive)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->query_unsensitive != query_unsensitive)
    mod_editprop->query_unsensitive = query_unsensitive;
}

void td_mod_editprop_set_query_list (TdModEditprop *mod_editprop, gchar *query_list)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->query_list != query_list)
    mod_editprop->query_list = query_list;
}

static void td_mod_editprop_set_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdModEditprop *mod_editprop;
  mod_editprop = TD_MOD_EDITPROP (object);
  switch (arg_id)
    {
    case ARG_NAME:
      td_mod_editprop_set_name (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_NAME_INTL:
      td_mod_editprop_set_name_intl (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_WIDGET_DATA1:
      td_mod_editprop_set_widget_data1 (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_WIDGET_DATA2:
      td_mod_editprop_set_widget_data2 (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_TYPE:
      td_mod_editprop_set_type (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_QUERY_REFRESH:
      td_mod_editprop_set_query_refresh (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_QUERY_VISIBLE:
      td_mod_editprop_set_query_visible (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_QUERY_UNSENSITIVE:
      td_mod_editprop_set_query_unsensitive (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    case ARG_QUERY_LIST:
      td_mod_editprop_set_query_list (mod_editprop, GTK_VALUE_STRING (*arg));
      break;
    default:
      break;
    }
}

static void td_mod_editprop_get_arg (GtkObject *object, GtkArg *arg, guint arg_id)
{
  TdModEditprop *mod_editprop;
  mod_editprop = TD_MOD_EDITPROP (object);
  switch (arg_id)
    {
    case ARG_NAME:
      GTK_VALUE_STRING (*arg) = mod_editprop->name;
      break;
    case ARG_NAME_INTL:
      GTK_VALUE_STRING (*arg) = mod_editprop->name_intl;
      break;
    case ARG_WIDGET_DATA1:
      GTK_VALUE_STRING (*arg) = mod_editprop->widget_data1;
      break;
    case ARG_WIDGET_DATA2:
      GTK_VALUE_STRING (*arg) = mod_editprop->widget_data2;
      break;
    case ARG_TYPE:
      GTK_VALUE_STRING (*arg) = mod_editprop->type;
      break;
    case ARG_QUERY_REFRESH:
      GTK_VALUE_STRING (*arg) = mod_editprop->query_refresh;
      break;
    case ARG_QUERY_VISIBLE:
      GTK_VALUE_STRING (*arg) = mod_editprop->query_visible;
      break;
    case ARG_QUERY_UNSENSITIVE:
      GTK_VALUE_STRING (*arg) = mod_editprop->query_unsensitive;
      break;
    case ARG_QUERY_LIST:
      GTK_VALUE_STRING (*arg) = mod_editprop->query_list;
      break;
    default:
      arg->type = GTK_TYPE_INVALID;
      break;
    }
}

/*****************************************************************************/
/*** Initialisation */
/*****************************************************************************/
static void td_mod_editprop_init (TdModEditprop *mod_editprop)
{
  mod_editprop->name = NULL;
  mod_editprop->name_intl = NULL;
  mod_editprop->type = "custom";
  mod_editprop->label = NULL;
  mod_editprop->widget = NULL;
  mod_editprop->widget_data1 = NULL;
  mod_editprop->widget_data2 = NULL;
  mod_editprop->widget_parent = NULL;
  mod_editprop->widget_list = NULL;
  mod_editprop->query_refresh = NULL;
  mod_editprop->query_visible = NULL;
  mod_editprop->query_unsensitive = NULL;
  mod_editprop->query_list = NULL;
  mod_editprop->dico = NULL;
}

static void td_mod_editprop_class_init (TdModEditpropClass *klass)
{
  GtkObjectClass *object_class;
  object_class = (GtkObjectClass*) klass;
  parent_class = gtk_type_class (gtk_object_get_type());
  gtk_object_add_arg_type ("TdModEditprop::name", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_NAME);
  gtk_object_add_arg_type ("TdModEditprop::name_intl", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_NAME_INTL);
  gtk_object_add_arg_type ("TdModEditprop::widget_data1", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_WIDGET_DATA1);
  gtk_object_add_arg_type ("TdModEditprop::widget_data2", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_WIDGET_DATA2);
  gtk_object_add_arg_type ("TdModEditprop::type", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_TYPE);
  gtk_object_add_arg_type ("TdModEditprop::query_refresh", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_QUERY_REFRESH);
  gtk_object_add_arg_type ("TdModEditprop::query_visible", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_QUERY_VISIBLE);
  gtk_object_add_arg_type ("TdModEditprop::query_unsensitive", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_QUERY_UNSENSITIVE);
  gtk_object_add_arg_type ("TdModEditprop::query_list", GTK_TYPE_STRING, GTK_ARG_READWRITE, ARG_QUERY_LIST);
  object_class->set_arg = td_mod_editprop_set_arg;
  object_class->get_arg = td_mod_editprop_get_arg;
  klass->set_widget = td_mod_editprop_set_widget;
  klass->set_dico = td_mod_editprop_set_dico;
}

GtkType td_mod_editprop_get_type (void)
{
  static GtkType mod_editprop_type = 0;
  if (!mod_editprop_type)
    {
      static const GtkTypeInfo mod_editprop_info =
      {
  	"TdModEditprop", sizeof (TdModEditprop), sizeof (TdModEditpropClass),
  	(GtkClassInitFunc) td_mod_editprop_class_init,
	(GtkObjectInitFunc) td_mod_editprop_init,
	NULL, NULL, (GtkClassInitFunc) NULL,
      };
      mod_editprop_type = gtk_type_unique (GTK_TYPE_OBJECT, &mod_editprop_info);
    }
  return mod_editprop_type;
}

/**
 * td_mod_editprop_new:
 * 
 * fr: Cr un nouveau composant de l'tabli
 *
 * en: Creates a new bench component
 * 
 * Return value: bench component
 **/

GtkObject *td_mod_editprop_new (void)
{
  return GTK_OBJECT (gtk_type_new (td_mod_editprop_get_type ()));
}

/*****************************************************************************/
/*** Affectations - Allocations */
/*****************************************************************************/

/**
 * td_mod_editprop_set_widget:
 * @mod_editprop: bench component
 * @widget: widget with data
 * @widget_parent: container of widget
 *
 * fr: Affecte le widget au composant de l'tabli
 *
 * en: Allocates the widget to bench component
 **/

void td_mod_editprop_set_widget (TdModEditprop *mod_editprop, GtkWidget *widget, GtkWidget *widget_parent)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->widget != widget)
    mod_editprop->widget = widget;
  if (widget_parent)
    {
      if (mod_editprop->widget_parent != widget_parent)
	mod_editprop->widget_parent = widget_parent;
    }
  else
    if (mod_editprop->widget_parent != widget)
      mod_editprop->widget_parent = widget;
}

/**
 * td_mod_editprop_set_widget_list:
 * @mod_editprop: bench component
 * @widget_list: list
 *
 * fr: Affecte la liste au composant de l'tabli
 *
 * en: Allocates the list to bench component
 **/

void td_mod_editprop_set_widget_list (TdModEditprop *mod_editprop, GtkWidget *widget_list)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->widget_list != widget_list)
    mod_editprop->widget_list = widget_list;
}

/**
 * td_mod_editprop_set_dico:
 * @mod_editprop: bench component
 * @dico: dictionary
 *
 * fr: Affecte le dictionnaire au composant de l'tabli
 *
 * en: Allocates the dictionary to bench component
 **/

void td_mod_editprop_set_dico (TdModEditprop *mod_editprop, GtkObject *dico)
{
  g_return_if_fail (mod_editprop != NULL);
  g_return_if_fail (TD_IS_MOD_EDITPROP (mod_editprop));
  if (mod_editprop->dico != dico)
    mod_editprop->dico = dico;
}
